<template>
  <div>
    <avue-crud v-model="form"
               :data="tableList"
               :option="option"
               :page.sync="page"
               :table-loading="loading">
      <!--top区域按钮-->
      <template slot="menuLeft" slot-scope="scope">
        <dynamic-button LocationType="top" type="table":butttonList="butttonList" @buttonClick="buttonClick" ></dynamic-button>
      </template>

      <!--menu区域按钮-->
      <template slot="menu" slot-scope="scope">
        <dynamic-button :scope="scope" LocationType="menu" type="table":butttonList="butttonList" @buttonClick="buttonClick" ></dynamic-button>
      </template>
    </avue-crud>
    <!-- 表格内按钮操作对话框表单   -->
    <dynamic-form ref="dynamicForm" :formList="formList" :title="formName" :visible.sync="visible"
                  style="display: none"></dynamic-form>
  </div>
</template>

<script>
export default {
  name: "dynamic-table",
  props: {
    componentVO: {
      type: Object,
      default: {}
    },
    inDialog: {
      type: Boolean,
      default: false
    },
    areasName: {
      type: String,
      default: ''//westArea导航区
    },
    sourceData: {
      //菜单源数据或者弹窗时按钮所属区域的上一区域选中数据
      type: Object,
      default: {}
    },
    paramVOS: {
      type: Object,
      default: {}
    }
  },
  data() {
    return {
      form: {},
      formName: '',
      loading: false,
      visible: false,
      page: {
        pageSize: 10,
        currentPage: 1,
        total: 5,
      },
      //表格头
      tableHeadList: [
        {
          align: "left",
          colspan: 1,
          field: "name",
          fieldType: "text",
          hidden: false,
          title: "名称",
          width: 100,
        },
        {
          align: "left",
          colspan: 1,
          field: "code",
          fieldType: "text",
          hidden: false,
          title: "编码",
          width: 100
        },
        {
          align: "left",
          colspan: 1,
          comboxKey: "EnumReviewType",
          field: "reviewtypetext",
          fieldType: "combox",
          hidden: false,
          sortField: "reviewtype",
          title: "类型",
          width: 80
        },
        {
          align: "left",
          colspan: 1,
          field: "content",
          fieldType: "textarea",
          hidden: false,
          title: "备注",
          width: 150
        },
        {
          align: "left",
          colspan: 1,
          comboxKey: "ProcessReviewLC${lcstatus}",
          field: "lcstatus_text",
          fieldType: "text",
          hidden: false,
          sortField: "lcstatus",
          title: "状态",
          width: 100
        },
        {
          align: "left",
          colspan: 1,
          field: "creator_name",
          fieldType: "text",
          hidden: false,
          sortField: "creator",
          title: "创建人",
          width: 80
        },
        {
          align: "left",
          colspan: 1,
          dateFormate: "yyyy-MM-dd HH:mm:ss",
          field: "createtime",
          fieldType: "date",
          hidden: false,
          title: "创建日期",
          width: 160
        }
      ],
      //表格数据
      tableList: [
        {
          code: "20220102",
          lastmodifier: "jhming",
          revisionseq: "1",
          versionvalue: "1",
          description: "",
          oid: "2E66D17B-E3E6-4725-BB83-93F4A20D4E20",
          versionseq: "1",
          content: "第二次中期评审犹太人",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-01-13 13:58:43.035",
          isfirstv: "1",
          lastmodifier_name: "姜红明",
          revisionoid: "4F400A1B-2313-4B11-894C-4F4F0B01368A",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "1月评审3",
          islastr: "1",
          lastmodifytime: "2022-07-15 16:04:43.703",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "CF350DE8-8E6D-470B-B273-4FD78D41BA4A",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-07-15 16:04:43.703"
        },
        {
          code: "w02",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "2f8d94b2-d65a-4f9b-9a71-caa3afd96459",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",

          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:35:45.03",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "31612b9f-022d-4b05-a24c-370a0fd457da",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试02",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:35:45.03",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "dfc0d8a5-ebe7-40f2-af56-fa437d3866e0",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:35:45.03"
        },
        {
          code: "webt01",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "38033242-3cb4-415c-9cc4-acdb86c2ee8f",
          versionseq: "0",
          content: "wbtest123修改后",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "待评审",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-01-21 10:04:08.053",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "3f3b2112-f356-4809-969b-1e63f6daa08d",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web端新增测试01",
          islastr: "1",
          lastmodifytime: "2022-02-09 09:45:56.044",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "d8975a06-4c1e-462b-af84-093068c58e9e",
          lcstatus: "Waiting",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-09 09:45:56.044"
        },
        {
          code: "w017",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "4011e1a7-9eb6-4b5c-89bf-847abff56682",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:37:53.247",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "648f5cf8-b42a-4b78-9928-883c94a83081",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试17",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:37:53.247",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "5d14e204-f085-4be0-9da6-b08c99172f8a",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:37:53.247"
        },
        {
          code: "w03",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "68583bec-b9ca-4321-8b66-a11d2298f51e",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:35:53.177",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "ff85f436-4dd1-498e-9665-44d53e27ac29",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试03",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:35:53.177",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "e0f20755-6954-4757-911e-7b9929fbe9a2",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:35:53.177"
        },
        {
          code: "20220102",
          lastmodifier: "jhming",
          revisionseq: "1",
          versionvalue: "1",
          description: "",
          oid: "2E66D17B-E3E6-4725-BB83-93F4A20D4E20",
          versionseq: "1",
          content: "第二次中期评审犹太人",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-01-13 13:58:43.035",
          isfirstv: "1",
          lastmodifier_name: "姜红明",
          revisionoid: "4F400A1B-2313-4B11-894C-4F4F0B01368A",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "1月评审3",
          islastr: "1",
          lastmodifytime: "2022-07-15 16:04:43.703",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "CF350DE8-8E6D-470B-B273-4FD78D41BA4A",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-07-15 16:04:43.703"
        },
        {
          code: "w02",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "2f8d94b2-d65a-4f9b-9a71-caa3afd96459",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",

          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:35:45.03",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "31612b9f-022d-4b05-a24c-370a0fd457da",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试02",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:35:45.03",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "dfc0d8a5-ebe7-40f2-af56-fa437d3866e0",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:35:45.03"
        },
        {
          code: "webt01",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "38033242-3cb4-415c-9cc4-acdb86c2ee8f",
          versionseq: "0",
          content: "wbtest123修改后",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "待评审",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-01-21 10:04:08.053",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "3f3b2112-f356-4809-969b-1e63f6daa08d",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web端新增测试01",
          islastr: "1",
          lastmodifytime: "2022-02-09 09:45:56.044",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "d8975a06-4c1e-462b-af84-093068c58e9e",
          lcstatus: "Waiting",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-09 09:45:56.044"
        },
        {
          code: "w017",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "4011e1a7-9eb6-4b5c-89bf-847abff56682",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:37:53.247",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "648f5cf8-b42a-4b78-9928-883c94a83081",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试17",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:37:53.247",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "5d14e204-f085-4be0-9da6-b08c99172f8a",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:37:53.247"
        },
        {
          code: "w03",
          lastmodifier: "1",
          revisionseq: "0",
          versionvalue: "1",
          description: "",
          oid: "68583bec-b9ca-4321-8b66-a11d2298f51e",
          versionseq: "0",
          content: "",
          checkinby: "",
          revisionrule: "ObjectVersion",
          reviewtypetext: "部门级",
          lctid: "ProcessReviewLC",
          reviewtype: "department",
          lcstatus_text: "编辑中",
          id: "",
          owner: "1",
          checkoutby: "",
          creator: "1",
          createtime: "2022-02-18 14:35:53.177",
          isfirstv: "1",
          lastmodifier_name: "测试",
          revisionoid: "ff85f436-4dd1-498e-9665-44d53e27ac29",
          btmname: "processreview",
          checkouttime: "",
          revisionvalue: "A",
          versionrule: "0",
          name: "web页面测试03",
          islastr: "1",
          lastmodifytime: "2022-02-18 14:35:53.177",
          copyfromversion: "",
          creator_name: "测试",
          nameoid: "e0f20755-6954-4757-911e-7b9929fbe9a2",
          lcstatus: "Editing",
          islastv: "1",
          checkintime: "",
          isfirstr: "1",
          ts: "2022-02-18 14:35:53.177"
        },
      ],
      // 表单数据
      formList: [
        {
          comboxKey: null,
          customClass: null,
          data: null,
          dateFormate: null,
          defaultValue: "",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "name",
          hidden: false,
          keyAttr: true,
          prefix: null,
          readOnly: false,
          referConfig: null,
          required: true,
          selectLibFlag: null,
          showField: null,
          suffix: '$',
          text: "名称",
          tooltips: '名称',
          type: "text",
          unique: false,
          verify: ""
        },
        {
          comboxKey: null,
          customClass: null,
          data: null,
          dateFormate: null,
          defaultValue: "",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "code",
          hidden: false,
          keyAttr: false,
          prefix: null,
          readOnly: false,
          referConfig: null,
          required: false,
          selectLibFlag: null,
          showField: null,
          suffix: null,
          disabled:true,
          text: "编码",
          tooltips: null,
          type: "text",
          unique: false,
          verify: ""
        },
        {
          comboxKey: "EnumReviewType",
          customClass: null,
          data: null,
          dateFormate: null,
          defaultValue: "department",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "reviewtype",
          hidden: false,
          keyAttr: false,
          prefix: null,
          readOnly: false,
          referConfig: null,
          required: false,
          selectLibFlag: null,
          showField: null,
          suffix: null,
          text: "类型",
          tooltips: null,
          type: "combox",
          unique: false,
          verify: "",
          dicData: [{
            label: '测试1',
            value: 'department'
          }, {
            label: '测试2',
            value: 'departments'
          }]
        },
        {
          comboxKey: null,
          customClass: null,
          data: null,
          dateFormate: null,
          defaultValue: "",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "creator",
          hidden: true,
          keyAttr: false,
          prefix: null,
          readOnly: true,
          referConfig: null,
          required: false,
          selectLibFlag: null,
          showField: null,
          suffix: null,
          text: "创建人",
          tooltips: null,
          type: "text",
          unique: false,
          verify: ""
        },
        {
          comboxKey: null,
          customClass: null,
          data: null,
          dateFormate: "yyyy-MM-dd HH:mm:ss",
          defaultValue: "",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "createtime",
          hidden: true,
          keyAttr: false,
          prefix: null,
          readOnly: false,
          referConfig: null,
          required: false,
          selectLibFlag: null,
          showField: null,
          suffix: null,
          text: "创建时间",
          tooltips: null,
          type: "datetime",
          unique: false,
          verify: ""
        },
        {
          comboxKey: null,
          customClass: null,
          data: null,
          dateFormate: null,
          defaultValue: "",
          displayExtension: "",
          extendAttrMap: null,
          extendAttrString: null,
          field: "content",
          hidden: false,
          keyAttr: false,
          prefix: null,
          readOnly: false,
          referConfig: null,
          required: false,
          selectLibFlag: null,
          showField: null,
          suffix: null,
          text: "备注",
          tooltips: null,
          type: "textarea",
          unique: false,
          verify: ""
        },
      ],
      // 按钮数据
      butttonList: [
        {
          actionVO: {
            actionCls: "",
            actionUsedType: "business",
            bsUrl: "null",
            createTime: "2013-11-01 15:17:45.000",
            creator: "eddieliu",
            csClass: "plm.uif.actions.client.AddAction",
            description: "创建业务对象",
            id: "add",
            lastModifier: "developer",
            lastModifyTime: "2013-11-01 15:17:45.000",
            licensors: null,
            name: "创建",
            oid: "65274704-5557-231C-E3EA-0B32B9BD5A0B"
          },
          areaType: "tab",
          authorization: true,
          children: null,
          createTime: "2022-07-18 17:29:10.000",
          creator: "developer",
          csUrl: "plm.uif.actions.client.AddAction",
          description: "",
          displayMode: "textandimage",
          hidden: false,
          iconPath: "",
          id: "add",
          lastModifier: "developer",
          lastModifyTime: "2022-07-18 17:29:10.000",
          name: "新增",
          oid: "DD34108A-5978-334C-7A2A-45F2EE158B1D",
          orderNum: 1,
          paramVOS: {
            form: "DepartmentProcessReviewForm",
            context: "EditDepartmentProcessReview",
            type: "processreview",
            initvalue: "reviewtype=department",
            location: 'top',
            buttonType: 'primary',
            buttonMethods: 'add'
          },
          pkComponent: "D99AD59E-563F-AB7A-F307-794B929114CD",
          pkParentOid: "",
          url: "null"
        },
        {
          actionVO: {
            actionCls: "",
            actionUsedType: "business",
            bsUrl: "BaseEditAction#doAction",
            createTime: "2013-11-09 10:32:41.000",
            creator: "eddieliu",
            csClass: "plm.uif.actions.client.EditAction",
            description: "修改业务对象",
            id: "edit",
            lastModifier: "developer",
            lastModifyTime: "2013-11-09 10:32:41.000",
            licensors: null,
            name: "修改",
            oid: "F8534EFE-130B-0CB3-D477-2AC7B19B7DC4"
          },
          areaType: "tab",
          authorization: true,
          children: null,
          createTime: "2022-07-18 17:29:10.000",
          creator: "developer",
          csUrl: "plm.uif.actions.client.EditAction",
          description: "",
          displayMode: "textandimage",
          hidden: false,
          iconPath: "",
          id: "edit",
          lastModifier: "developer",
          lastModifyTime: "2022-07-18 17:29:10.000",
          name: "修改",
          oid: "F50F37CE-26FF-8BC1-F87A-FFD9CFA8CE57",
          orderNum: 2,
          paramVOS: {
            form: "DepartmentProcessReviewForm",
            checkNotOperation: "${lcstatus}=Auditing&${lcstatus}=Waiting",
            location: 'menu',
            buttonType: 'text',
            icon: "el-icon-edit",
            buttonMethods: 'edit'
          },
          pkComponent: "D99AD59E-563F-AB7A-F307-794B929114CD",
          pkParentOid: "",
          url: "BaseEditAction#doAction"
        },
        {
          actionVO: {
            actionCls: "",
            actionUsedType: "business",
            bsUrl: "BaseDeleteAction",
            createTime: "2013-11-09 10:33:08.000",
            creator: "1",
            csClass: "plm.uif.actions.client.DeleteAction",
            description: "删除业务对象",
            id: "del",
            lastModifier: "developer",
            lastModifyTime: "2013-11-09 10:33:08.000",
            licensors: null,
            name: "删除",
            oid: "2655E9F0-014B-DFEC-6F92-A6D1C51FDA19"
          },
          areaType: "tab",
          authorization: true,
          children: null,
          createTime: "2022-07-18 17:29:10.000",
          creator: "developer",
          csUrl: "plm.uif.actions.client.DeleteAction",
          description: "",
          displayMode: "textandimage",
          hidden: false,
          iconPath: "",
          id: "del",
          lastModifier: "developer",
          lastModifyTime: "2022-07-18 17:29:10.000",
          name: "删除",
          oid: "A8914C35-721B-A1E3-1EEE-3A9196DF5EC9",
          orderNum: 3,
          paramVOS: {
            owner: "true",
            checkNotOperation: "${lcstatus}=Auditing&${lcstatus}=Waiting",
            state: "Editing",
            location: 'menu',
            buttonType: 'text',
            icon: "el-icon-delete",
            buttonMethods: 'delete'
          },
          pkComponent: "D99AD59E-563F-AB7A-F307-794B929114CD",
          pkParentOid: "",
          url: "BaseDeleteAction"
        },
        {
          actionVO: {
            actionCls: "",
            actionUsedType: "business",
            bsUrl: "BaseStartWorkflowAction#doAction",
            createTime: "2014-03-17 10:14:40.000",
            creator: "developer",
            csClass: "plm.uif.actions.client.LaunchWorkFlowAction",
            description: "启动流程",
            id: "launchworkflow",
            lastModifier: "developer",
            lastModifyTime: "2014-03-17 10:14:40.000",
            licensors: null,
            name: "启动流程",
            oid: "56FE9470-AA2B-403B-F029-0A120FC94536"
          },
          areaType: "tab",
          authorization: true,
          children: null,
          createTime: "2022-07-18 17:29:10.000",
          creator: "developer",
          csUrl: "plm.uif.actions.client.LaunchWorkFlowAction",
          description: "",
          displayMode: "textandimage",
          hidden: false,
          iconPath: "",
          id: "launchworkflow",
          lastModifier: "developer",
          lastModifyTime: "2022-07-18 17:29:10.000",
          name: "审签",
          oid: "9963FA86-F146-FBD3-2AC2-51A7AAAAB825",
          orderNum: 4,
          paramVOS: {
            owner: "true",
            autoSubmitFirst: "false",
            flowtemplates: "工艺评审审签流程",
            state: "Editing",
            type: "processreview",
            location: 'top',
            buttonMethods: 'form'
          },
          pkComponent: "D99AD59E-563F-AB7A-F307-794B929114CD",
          pkParentOid: "",
          url: "BaseStartWorkflowAction#doAction"
        },
      ]
    }
  },
  computed: {
    option() {
      return {
        index: true,
        addBtn: false,
        editBtn: false,
        delBtn: false,
        height: 'auto',
        indexFixed: false,
        menuFixed: false,
        column: this.updatedColumns,
      };
    },
    updatedColumns() {
      return this.tableHeadList.map(item => {
        const typeValue = item.fieldType === 'text' || item.fieldType === 'combox' ? 'input' : item.fieldType; // 表单Type类型

        return {
          align: item.align,
          colspan: item.colspan,
          prop: item.field,
          type: typeValue,
          hidden: item.hidden,
          label: item.title,
          width: item.width,
        };
      });
    },
  },
  methods: {
    buttonClick(scope, item) {
      this.formName = item.name;

      function handleAdd() {
        this.visible = true;
      }

      function handleEdit() {
        this.visible = true;
        this.$refs.dynamicForm.form = scope.row;
      }

      function handleDelete() {
        this.$message.success('删除成功！');
      }

      const methodHandlers = {
        add: handleAdd.bind(this),
        edit: handleEdit.bind(this),
        delete: handleDelete.bind(this),
      };

      const method = item.paramVOS.buttonMethods;
      const handler = methodHandlers[method];
      if (handler) {
        handler();
      } else {
        this.$message.error('请重新配置按钮！')
      }
    }
  }
}
</script>

<style scoped>

</style>
